//-----------------------------------------------------------------------------+
#property copyright "Copyright  2010, Trishkin Artyom A."
#property link      "support@goldsuccess.ru"
//-----------------------------------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>
//==============================================================================
// ---------------------------   ---------------------------+
//==============================================================================
extern string P_Expert= "-- Experts Variables --";
extern bool   TradeBuy=true;                                   //   Buy, true = , false =  
extern bool   TradeSell=false;                                  //   Sell, true = , false =  
extern bool   UseEquClose=false;                                //   -    true = , false = 
extern bool   TrackLossEquity=false;                            //        true = , false = 
//-------------------------------------
extern double StartLots=1;  //  .
extern double MaxLots=100;  //     -     .
extern double DeltaLots=3; //    -.
//------------------------------------- 
extern int obSL=0; //   -  . 0- .     0 - .
extern int    stoploss=100;                                     // -
extern int    TakeProfit=100;                                   //  TakeProfit  
extern int    DistanceOpenPositions=100;                             //     
extern double PercentEquityForClose=0;                       //       
extern double PercentLossEquityForClose=0;                   //       
extern int    NumberLossPoseForCloseEquUP=0;                   //       
extern int    NumberLossPoseForCloseEquDN=0;                   //       
//-------     ------------------------------+
extern string P_Performanc= "-- Parameters for Trades --";
extern int    NumberOfTry = 5;                                 //     
extern int    Slippage    = 3;                                 //   
extern bool   UseSound    = false;                              //   
string        SoundSuccess= "ok.wav";                          //  
string        SoundError  = "timeout.wav";                     //  
string        SoundClose  = "Close_order.wav";                 //  
//==============================================================================
int      tf, dg, sp;
int      Magic, Level_old, Level_new, TradeDirection;
int      NumberUpLevels=1;                                     //    
int      NumberDnLevels=1;                                     //    
int      MassUpLen, MassDnLen;
string   Prefix, Exp_Name, NameGL_Equ, NameGL_Add, NameGL_Loss, PriceFirstSell;
string   end1, end2, type, sy;
color    clUP, clDN;
double   EquStart, EquAdd, EquClose, EquLoss, EquPercLoss;
double   CenterLevel, GL_CenterLevel, PointX;
//double   pGL1, pGL2;
double Lots;
double   pa, pb;
double   MassUpLev[5];
double   MassDnLev[5];
double   MassCtLev[1];
double   HighestLev;
double   LowestLev;
bool     CloseFact=true;
bool     FirstStart=true;
//bool     WriteAboutFStart=false;
//==============================================================================
//----------------------   --------------------------------+
//==============================================================================
bool   AllMessages, PrintEnable;
color  clOpenBuy    = MediumBlue;      //    
color  clOpenSell   = OrangeRed;       //    
color  clCloseBuy   = Blue;            //    
color  clCloseSell  = IndianRed;       //    
color  clModifyBuy  = DodgerBlue;      //    
color  clModifySell = Tomato;          //    
color  clDelete     = Yellow;          //    
bool   MarketWatch  = True;            //    "Market Watch".
bool   gbDisabled   = False;           //   
int    modeSetOrders= 1;               //   :
                                       //  0 -   
                                       //  1 -  
                                       //  2 -    
//----------------------------------------------------------------
//==============================================================================
int init()
{
   tf=Period();
   sy=Symbol();
   pa=MarketInfo(sy,MODE_ASK);
   pb=MarketInfo(sy,MODE_BID);
   dg=MarketInfo(sy,MODE_DIGITS);
   Level_old=MarketInfo(Symbol(),MODE_STOPLEVEL );             // .   
   if(Digits==5 || Digits==3) PointX = Point * 10;             //  Point  - 
   if(Digits==4 || Digits==2) PointX = Point;
   Exp_Name=WindowExpertName();                                //  
   Prefix=Exp_Name+"_M"+Period();                              //    
   Magic=GetMagic(Exp_Name+Symbol(),Period());                 //  
   NameGL_Equ=Prefix+"_GL_Equ";
   NameGL_Add=Prefix+"_GL_Add";
   NameGL_Loss=Prefix+"_GL_Loss";
   PriceFirstSell=Prefix+"_GL_PFSell";
   if(!GlobalVariableCheck(NameGL_Equ)) {                      //        NameGL_Equ
      EquStart=AccountEquity();                                //   = 
      EquAdd=NormalizeDouble(EquStart/100*PercentEquityForClose,dg); //   ,       
      EquPercLoss=NormalizeDouble(EquStart/100*PercentLossEquityForClose,dg);//  ,      . 
      GlobalVariableSet(NameGL_Equ,EquStart);                  //         
      GlobalVariableSet(NameGL_Add,EquAdd);
      GlobalVariableSet(NameGL_Loss,EquLoss);
      }
   else {
      EquStart=GlobalVariableGet(NameGL_Equ);      //     ,    =   
      EquAdd=GlobalVariableGet(NameGL_Add);
      EquPercLoss=GlobalVariableGet(NameGL_Loss);
      }
   double p1=GlobalVariableGet(NameGL_Equ);
   double p2=GlobalVariableGet(NameGL_Add);
   double p3=GlobalVariableGet(NameGL_Loss);
   EquClose=NormalizeDouble(p1+p2,dg);
   EquLoss= NormalizeDouble(p1-p3,dg);
   if (PercentEquityForClose<=0)          PercentEquityForClose=PointX;
   if (NumberLossPoseForCloseEquUP<=0)    NumberLossPoseForCloseEquUP=1;
   if (NumberLossPoseForCloseEquDN<=0)    NumberLossPoseForCloseEquDN=1;
   if (DistanceOpenPositions<=0 || 
       DistanceOpenPositions<=Level_old)  DistanceOpenPositions=Level_old+1;
   if (TakeProfit<=Level_old)             TakeProfit=Level_old+1;
//==============================================================================
// -------------       ----------------+
//==============================================================================
   ArrayResize(MassUpLev, NumberUpLevels);                     //    ...
   ArrayResize(MassDnLev, NumberDnLevels);                     // ...   
   ArrayInitialize(MassCtLev, 0);                              //   
   ArrayInitialize(MassUpLev, 0);                              //   
   ArrayInitialize(MassDnLev, 0);                              //   
   CenterLevel=pa;
   MassCtLev[0]=CenterLevel;
// -----------------------------------------------------------------------------   
   return(0);
}
//==============================================================================
int deinit()                              // .  deinit()
{
// --------    ,     --------
   string Name_Del[1]; 
   int Quant_Del=0;                    
   int Quant_Objects=ObjectsTotal();   
   int LenPref=StringLen(Prefix);
   ArrayResize(Name_Del,Quant_Objects);
   for(int k=0; k<Quant_Objects; k++) {
         string Obj_Name=ObjectName(k);   
         string Head=StringSubstr(Obj_Name,0,LenPref);
         if (Head==Prefix) {                              
               Quant_Del+=1;        
               Name_Del[Quant_Del-1]=Obj_Name;
            }
     }
   for(int i=0; i<Quant_Del; i++)    
      ObjectDelete(Name_Del[i]); 
// -----     ,     -----
   if (!IsTesting()) Comment("");                                 //   (  )
   else if (IsTesting())                                          //   ,  ...
      if(GlobalVariableCheck(NameGL_Equ)) {                       // ...        NameGL_Equ ...
         GlobalVariableDel(NameGL_Equ);                           // ...  
         GlobalVariableDel(NameGL_Add);
         GlobalVariableDel(NameGL_Loss);
         GlobalVariableDel(PriceFirstSell);
         }
   return;                                                        //   deinit()
}
//==============================================================================
int start()
{
   tf=Period();
   sy=Symbol();
   pa=MarketInfo(sy,MODE_ASK);
   pb=MarketInfo(sy,MODE_BID);
   sp=MarketInfo(sy,MODE_SPREAD);
   Level_new=MarketInfo(sy,MODE_STOPLEVEL );                      //      
   if (Level_old!=Level_new) {                                    //    ,   
      Level_old=Level_new;                                        //  " "
      }
   if (DistanceOpenPositions<=Level_new)  DistanceOpenPositions=Level_new+1;
   if (TakeProfit<=Level_new)             TakeProfit=Level_new+1;
//==============================================================================
// -------------------   StopLevel   --------------------+
//==============================================================================
   color cl=FireBrick;
   string RectUP=Prefix+"_RectUp_StLevel";
   double pUP1=pa;
   double pUP2=NormalizeDouble(pa+Level_new*PointX,dg);
   SetRectangle(cl, RectUP, Time[3], pUP1, Time[0]+3*Period()*60, pUP2);
   string RectDN=Prefix+"_RectDn_StLevel";
   double pDN1=pb;
   double pDN2=NormalizeDouble(pb-Level_new*PointX,dg);
   SetRectangle(cl, RectDN, Time[3], pDN1, Time[0]+3*Period()*60, pDN2);
   informations();
//==============================================================================
// ----------------------    Sell ------------------------+
//==============================================================================
   if (FirstStart) {                                              //     
      if(!GlobalVariableCheck(PriceFirstSell)) {                  //    .  PriceFirstSell ( )
         GlobalVariableSet(PriceFirstSell,0);                     //    0
         double tp=NormalizeDouble(pb-TakeProfit*PointX,dg);
         string New_Comm="__Sell";
         Print(" :  Sell");
         OpenPosition(sy,OP_SELL,Lots,0,tp,Magic,New_Comm);
         if (ExistPositions(sy,OP_SELL,Magic))
            GlobalVariableSet(PriceFirstSell,OrderOpenPrice());  
         }
      }
//==============================================================================
// -----------------     -------------------+
//==============================================================================
   SetLevels();
   if (pa>NormalizeDouble(CenterLevel+DistanceOpenPositions*PointX,dg)) {
      CenterLevel=NormalizeDouble(CenterLevel+DistanceOpenPositions*PointX,dg);
      MassCtLev[0]=CenterLevel;
      SetLevels();
      }
   if (pb<NormalizeDouble(CenterLevel-DistanceOpenPositions*PointX,dg)) {
      CenterLevel=NormalizeDouble(CenterLevel-DistanceOpenPositions*PointX,dg);
      MassCtLev[0]=CenterLevel;
      SetLevels();
      }
      if (NormalizeDouble(pa-CenterLevel,dg)>0.5*PointX &&
          NormalizeDouble(CenterLevel-Low[1],dg)>=0.5*PointX)  OpenPosOnTradeMode(OP_BUY,  NormalizeDouble(CenterLevel,dg));
      if (NormalizeDouble(CenterLevel-pb,dg)>0.5*PointX &&
          NormalizeDouble(High[1]-CenterLevel,dg)>=0.5*PointX) OpenPosOnTradeMode(OP_SELL, NormalizeDouble(CenterLevel,dg));
//==============================================================================
// ------------       --------------+
//==============================================================================
   int    TotalLoss=0;
   int    NumPoseForClose=0;
   double loss=0;
   double p1=GlobalVariableGet(NameGL_Equ);
   double p2=GlobalVariableGet(NameGL_Add);
   double p3=GlobalVariableGet(NameGL_Loss);
   EquClose=NormalizeDouble(p1+p2,dg);
   EquLoss= NormalizeDouble(p1-p3,dg);
   if (UseEquClose) {
      if (AccountEquity()>=EquClose) {
         EquStart=AccountEquity();
         GlobalVariableSet(NameGL_Equ,EquStart);
         if (TotalLossPose()==0) {
            Print("    ",DoubleToStr(EquClose,2),",   ");
            CloseFact=false;
            return(0);
            }
         if (NumberLossPoseForCloseEquUP==1) {
            loss=ClosePosWithMaxLossInCurrency(sy, Magic);
            if (OrderType()==OP_BUY) type="Buy"; else type="Sell";
            Print("    ",DoubleToStr(EquClose,2),
                  ",   ",type,"    (",DoubleToStr(loss,2),")");
            }
         else if (NumberLossPoseForCloseEquUP>1) {
            TotalLoss=TotalLossPose();
            if (TotalLoss<NumberLossPoseForCloseEquUP) NumPoseForClose=TotalLoss; else NumPoseForClose=NumberLossPoseForCloseEquUP;
            SetEndString(NumPoseForClose);
            Print("    ",DoubleToStr(EquClose,2),
                  ",  ",NumPoseForClose, " ", end1, " ", end2);
            CloseLoss(NumPoseForClose);
            }
         CloseFact=false;
         }
      else if (AccountEquity()<=EquLoss) {
         if (TrackLossEquity) {
//         if (!CloseFact) {
            if (TotalLossPose()==0) {
               Print("    ",DoubleToStr(EquLoss,2),",   ");
               CloseFact=false;
               return(0);
               }
            if (NumberLossPoseForCloseEquDN==1) {
               loss=ClosePosWithMaxLossInCurrency(sy, Magic);
               if (OrderType()==OP_BUY) type="Buy"; else type="Sell";
               Print("    ",DoubleToStr(EquLoss,2),
                     ",   ",type,"    (",DoubleToStr(loss,2),")");
               }
            else if (NumberLossPoseForCloseEquDN>1) {
               TotalLoss=TotalLossPose();
               if (TotalLoss<NumberLossPoseForCloseEquDN) NumPoseForClose=TotalLoss; else NumPoseForClose=NumberLossPoseForCloseEquDN;
               SetEndString(NumPoseForClose);
               Print("    ",DoubleToStr(EquLoss,2),
                     ",  ",NumPoseForClose, " ", end1, " ", end2);
               CloseLoss(NumPoseForClose);
               }
            CloseFact=true;
            EquStart=AccountEquity();                                //   = 
            EquPercLoss=NormalizeDouble(EquStart/100*PercentLossEquityForClose,dg);//  ,      . 
            GlobalVariableSet(NameGL_Equ,EquStart);                  //         
            GlobalVariableSet(NameGL_Loss,EquPercLoss);
            p1=GlobalVariableGet(NameGL_Equ);
            p2=GlobalVariableGet(NameGL_Add);
            p3=GlobalVariableGet(NameGL_Loss);
            EquClose=NormalizeDouble(p1+p2,dg);
            EquLoss= NormalizeDouble(p1-p3,dg);
            Print("   = ", EquStart, ",    = ",EquPercLoss, ",  .  = ", EquLoss);
            }
         }
      }
   return(0);  // --------------------   start() -----------------------+
}

//==============================================================================
// ---------------------------------  ----------------------------------+
//==============================================================================
//==============================================================================
// ----------------------------   -----------------------------+
//==============================================================================
//==============================================================================
// ------------------       --------------------+
//==============================================================================
void OpenPosOnTradeMode(int type, double price) {
   double tp=0, pp=0,SL=0;
   string New_Comm="";
   int total, cnt;
   Print("   ",price,",     ");
   if (type==OP_BUY) 
   {
      tp=NormalizeDouble(pa+TakeProfit*PointX,dg);
      New_Comm="  _Buy";
      if (!PresentPosNearestLev(type, price)) 
      {
         Print("  ",DoubleToStr(price,dg),"   ,  Buy");
         total=OrdersTotal();
         for(cnt=total-1;cnt>=0;cnt--)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)// && (OrderMagicNumber()==cmagic))
            {
               if(OrderProfit()<0)
               {
                   Lots=Lots+DeltaLots;
                   if (Lots>MaxLots) Lots=StartLots;
               }   
               else Lots=StartLots;
               break;
            }
         }   
         if (cnt<0) Lots=StartLots; //   
if (Lots==StartLots)SL=Ask-stoploss*Point; //      -.        ,    .
         OpenPosition(sy,OP_BUY,Lots,SL,tp,Magic,New_Comm);
         if(obSL>0)
         {
         total=OrdersTotal();
         for(cnt=total-1;cnt>=0;cnt--)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderStopLoss()<SL && OrderLots()==StartLots)// && (OrderMagicNumber()==cmagic))
            {
                OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0);
                Sleep(3000); // 3 .    -   .
            }
         }   
         }
      }
   }
   return;
}
// ----------------------------------------------------------------------------+
// ----------------------------------------------------------------------------+
bool PresentPosNearestLev(int type, double price) {
   double delta=NormalizeDouble((DistanceOpenPositions/2)*PointX,dg);
   int i;   
   for (i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS)) {
         if (OrderMagicNumber()!=Magic)   continue;
         if (OrderSymbol()!=sy)           continue;
         if (OrderType()!=type)           continue;
         if (MathAbs(NormalizeDouble(OrderOpenPrice()-price,dg))<=delta) {
            if (OrderType()==OP_BUY) string ot="Buy"; else ot="Sell";
            Print("  ",DoubleToStr(price,dg),"     ",ot,",    ",DoubleToStr(OrderOpenPrice(),dg));
            return(true);
            }
         }
      }
   return(false);   
}
//+----------------------------------------------------------------------------+
void SetLevels() {
   int i;
   double step, lev;
   MassCtLev[0]=CenterLevel;
   string NameLevelCT=Prefix+"_CenterLevel";                   //   
   SetArrow(4, MediumSpringGreen, NameLevelCT, Time[0], CenterLevel, 0);
   
// --------------------      -----------------------+
   for (i=0; i<NumberUpLevels; i++) {
      step=((i+1)*DistanceOpenPositions)*PointX;                    //   
      lev=NormalizeDouble(MassCtLev[0]+step,dg);               //   i- 
      MassUpLev[i]=lev;                                        //  
      clUP=DeepSkyBlue;                                        //   
      string NameLevelUP=Prefix+"_UpLevel_"+DoubleToStr(i,0);  //  
      SetArrow(4, clUP, NameLevelUP, Time[0], lev, 0);         //  i-
      }
// --------------------      ------------------------+
   for (i=0; i<NumberDnLevels; i++) {
      step=((i+1)*DistanceOpenPositions)*PointX;                    //   
      lev=NormalizeDouble(MassCtLev[0]-step,dg);               //   i- 
      MassDnLev[i]=lev;                                        //  
      clDN=Gold;                                               //   
      string NameLevelDN=Prefix+"_DnLevel_"+DoubleToStr(i,0);  //  
      SetArrow(4, clDN, NameLevelDN, Time[0], lev, 0);         //  
      }
   MassUpLen=ArrayRange(MassUpLev,0);
   MassDnLen=ArrayRange(MassDnLev,0);
   HighestLev=MassUpLev[MassUpLen-1];
   LowestLev =MassDnLev[MassDnLen-1];
   return;
}
//+----------------------------------------------------------------------------+
void CloseLoss(int numLoss) {
   for (int i=0; i<numLoss; i++) ClosePosWithMaxLossInCurrency(sy, Magic);
}
//+----------------------------------------------------------------------------+
void informations() {
   string Text, nmEqu, font;
   color  cl;
   int    angle, xDist, yDist, size;
//+----------------------------------------------------------------------------+
   Text=" : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_Balance";
   angle=2; xDist=10; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(AccountBalance(),2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_AccBalance";
   angle=2; xDist=150; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text=" : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_Equity";
   angle=2; xDist=10; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(AccountEquity(),2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_AccEquity";
   angle=2; xDist=150; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text="  : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_CloseEquity";
   angle=2; xDist=10; yDist=30;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(EquClose,2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_ClsEquity";
   angle=2; xDist=150; yDist=30;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text=" : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_CriticEquity";
   angle=2; xDist=10; yDist=10;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(EquLoss,2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_CriticEquity";
   angle=2; xDist=150; yDist=10;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
/*   
   Text=" : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_Mode";
   angle=2; xDist=220; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   if (MarketTrade) Text=""; else Text="";
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_Mode";
   angle=2; xDist=320; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
*/   
//+----------------------------------------------------------------------------+
   Text=" Buy: ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_LossBuy";
   angle=2; xDist=220; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(NumLossPos(OP_BUY),0);
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_LossBuy";
   angle=2; xDist=320; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text=" Sell: ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_LossSell";
   angle=2; xDist=220; yDist=30;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(NumLossPos(OP_SELL),0);
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_LossSell";
   angle=2; xDist=320; yDist=30;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
}
//==============================================================================
// -----------------------------   -----------------------------+
//==============================================================================
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="") {
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;

   if (op==OP_BUY) {
      if (!TradeBuy) {
         Print("  Buy    ");
         return;
         }
      }
   if (op==OP_SELL) {
      if (!TradeSell) {
         Print("  Sell    ");
         return;
         }
      }
  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("OpenPosition(): Function stopped");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000); //Sleep_RND(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, co, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(SoundSuccess); break;
    } else {
      err=GetLastError();
      if (UseSound) PlaySound(SoundError);
      if (pa==0 && pb==0) Message("Check in the MarketWatch presence of the symbol "+sy);
      //    
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //   
      if (err==2  ||                //  
          err==64 ||                //  
          err==65 ||                //   
          err==133)                 //  
          {
        gbDisabled=True; break;     //  
      }
      //  
      if (err==4   ||               //   
          err==131 ||               //  
          err==132)                 //  
          {
        Sleep(1000*300); break; // Sleep_RND(1000*300);
      }
      if (err==128 ||               //     
          err==142 ||               //    
          err==143)                 //     
          {
        Sleep(1000*66.666); // Sleep_RND(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          if (UseSound) PlaySound(SoundSuccess); break;
        }
      }
      if (err==140  ||              //   
          err==148  ||              //       ,  
          err==4110 ||              //    .    
          err==4111)                //    .    
          break;
      if (err==141) /*Sleep(1000*100);*/ Sleep_RND(1000*100); //   
      if (err==145) /*Sleep(1000*17);*/  Sleep_RND(1000*17);  //  ,       
      if (err==146) while (IsTradeContextBusy()) /*Sleep(1000*11);*/ Sleep_RND(1000*11);  //   
      if (err!=135) /*Sleep(1000*7.7);*/ Sleep_RND(1000*7.7);                             //  
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0,color cl=CLR_NONE) {
  bool   fm;
              cl=IIFc(OrderType()==OP_BUY
              || OrderType()==OP_BUYLIMIT
              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        er=GetLastError();
        if (UseSound) PlaySound(SoundError);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}
//+----------------------------------------------------------------------------+
double ClosePosWithMaxLossInCurrency(string sy="", int mn=-1) {
   double pr=0;
   int    i, k=OrdersTotal(), np=-1;

   for (i=k-1; i>=0; i--) {
      if (OrderSelect(i, SELECT_BY_POS)) {
         if (OrderSymbol()!=sy)        continue;
         if (OrderType()>1)            continue;
         if (OrderMagicNumber()!=mn)   continue;
         if (OrderProfit()+OrderSwap()+OrderCommission()<pr) {
            pr=OrderProfit()+OrderSwap()+OrderCommission();
            np=i;
            }
         }
      }
   if (np>=0) {
      if (OrderSelect(np, SELECT_BY_POS)) {
         ClosePosBySelect();
         }
      }
   return(pr);
}
//+----------------------------------------------------------------------------+
void ClosePosBySelect() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    err, it;

  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; clClose=clCloseBuy;
      } else {
        pp=pa; clClose=clCloseSell;
      }
      ll=OrderLots();
      fc=OrderClose(OrderTicket(), ll, NormalizeDouble(pp,dg), Slippage, clClose);
      if (fc) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        err=GetLastError();
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
              ErrorDescription(err),", try ",it);
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
      }
    }
  } else Print("  . Close ",GetNameOP(OrderType()));
}
//==============================================================================
// -------------------------   --------------------------+
//==============================================================================
void Sleep_RND(int _Pausa) {
   MathSrand(TimeLocal());
   MathRand();
   Sleep(MathRound(_Pausa*MathRand()/32767+_Pausa/5));
   return;
}
//+----------------------------------------------------------------------------+
color IIFc(bool condition, color ifTrue, color ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
   if (TimeFrame==0) TimeFrame=Period();
      switch (TimeFrame) {
         case PERIOD_M1:  return("M1");
         case PERIOD_M5:  return("M5");
         case PERIOD_M15: return("M15");
         case PERIOD_M30: return("M30");
         case PERIOD_H1:  return("H1");
         case PERIOD_H4:  return("H4");
         case PERIOD_D1:  return("Daily");
         case PERIOD_W1:  return("Weekly");
         case PERIOD_MN1: return("Monthly");
         default:         return("UnknownPeriod");
         }
}
//+----------------------------------------------------------------------------+
void Message(string m) {
   static string prevMessage="";
   Comment(m);
   if (StringLen(m)>0 && PrintEnable) {
      if (AllMessages || prevMessage!=m) {
         prevMessage=m;
         Print(m);
         }
      }
}
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
   switch (op) {
      case OP_BUY      : return("Buy");
      case OP_SELL     : return("Sell");
      case OP_BUYLIMIT : return("Buy Limit");
      case OP_SELLLIMIT: return("Sell Limit");
      case OP_BUYSTOP  : return("Buy Stop");
      case OP_SELLSTOP : return("Sell Stop");
      default          : return("Unknown Operation");
      }
}
//+----------------------------------------------------------------------------+
int GetMagic(string symbolstring, int multiplier) {
   int res=0;
   int len=StringLen(symbolstring);
   for(int i=0; i<len; i++)
       res+=StringGetChar(symbolstring,i);      
   return(res*multiplier);
}
//+----------------------------------------------------------------------------+
void SetEndString(int num) {         
   int x = num%10;      //  
   switch (x) {
      case 1:  end1=""; end2=""; break;
      case 2:  end1=""; end2=""; break;
      case 3:  end1=""; end2=""; break;
      case 4:  end1=""; end2=""; break;
      default: end1=""; end2=""; break;
      }
   return;
}
//==============================================================================
// ------------------------    --------------------------+
//==============================================================================
int NumLossPos(int type) {
   int    numloss=0;
   for (int i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS)) {
         if (OrderType()!=type)           continue;
         if (OrderSymbol()!=sy)           continue;
         if (OrderMagicNumber()!=Magic)   continue;
         if (OrderProfit()+OrderSwap()+OrderCommission()<0) numloss++;
         }
      }
   return(numloss);
}
//+----------------------------------------------------------------------------+
int TotalLossPose() {
   int    numloss=0;
   for (int i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS)) {
         if (OrderType()>1)               continue;
         if (OrderSymbol()!=sy)           continue;
         if (OrderMagicNumber()!=Magic)   continue;
         if (OrderProfit()+OrderSwap()+OrderCommission()<0) numloss++;
         }
      }
   return(numloss);
}
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) 
{
   int i, k=OrdersTotal();
   if (sy=="0") sy=Symbol();
   for (i=0; i<k; i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol()!=sy)        continue;
         if (OrderType()!=op)          continue;
         if (OrderMagicNumber()!=mn)   continue;
         if (ot<=OrderOpenTime()) return(True);
         }
      }
  return(False);
}
//==============================================================================
// ---------------------------   ----------------------------+
//==============================================================================
void SetArrow(int cd, color cl, string nm="", datetime t1=0, double p1=0, int sz=0) {
   if (nm=="") nm=DoubleToStr(Time[0], 0);
   if (t1<=0) t1=Time[0];
   if (p1<=0) p1=Bid;
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_ARROW, 0, 0, 0);
   ObjectSet(nm, OBJPROP_TIME1    , t1);
   ObjectSet(nm, OBJPROP_PRICE1   , p1);
   ObjectSet(nm, OBJPROP_ARROWCODE, cd);
   ObjectSet(nm, OBJPROP_COLOR    , cl);
   ObjectSet(nm, OBJPROP_WIDTH    , sz);
}
//+----------------------------------------------------------------------------+
void SetRectangle(color cl, string nm="", datetime t1=0, double p1=0, datetime t2=0, double p2=0, int sz=0) {
   if (nm=="") nm=DoubleToStr(Time[0], 0);
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   ObjectSet(nm, OBJPROP_TIME1    , t1);
   ObjectSet(nm, OBJPROP_PRICE1   , p1);
   ObjectSet(nm, OBJPROP_TIME2    , t2);
   ObjectSet(nm, OBJPROP_PRICE2   , p2);
   ObjectSet(nm, OBJPROP_COLOR    , cl);
   ObjectSet(nm, OBJPROP_WIDTH    , sz);
}
//+----------------------------------------------------------------------------+
void SetText(string Text, color cl, string nm, int angle, int x, int y, string font, int sz=0) {
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0, 0);
   ObjectSet(nm, OBJPROP_CORNER   , angle);
   ObjectSet(nm, OBJPROP_XDISTANCE, x);
   ObjectSet(nm, OBJPROP_YDISTANCE, y);
   ObjectSet(nm, OBJPROP_WIDTH    , sz);
   ObjectSetText(nm, Text, sz, font, cl);
   }
//+----------------------------------------------------------------------------+

